#line 1 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
#line 22 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
 void delay10ms(void);
 void delay100ms(void);
 void initial_config(void);
 void var_delay_us(char v);
 void gera_beep(char d,char e);
 void beep_erros(char n);
 void nonferrous();
 void ferrous();
 void dinamic_adjust_value();
 void efeito_sonoro_taranra();
 void detecta_metal();
 void testa_osc_sensor();
 void oscillator_stability();


sbit lednf at PORTB2_bit;
sbit ledf at PORTB3_bit;
sbit buzzer at PORTB1_bit;
sbit led0 at PORTD0_bit;
sbit led1 at PORTD1_bit;
sbit led2 at PORTD2_bit;
sbit led3 at PORTD3_bit;
sbit led4 at PORTD5_bit;
sbit led5 at PORTD6_bit;


sbit lednf_Direction at DDB2_bit;
sbit ledf_Direction at DDB3_bit;
sbit buzzer_Direction at DDB1_bit;
sbit led0_Direction at DDD0_bit;
sbit led1_Direction at DDD1_bit;
sbit led2_Direction at DDD2_bit;
sbit led3_Direction at DDD3_bit;
sbit led4_Direction at DDD5_bit;
sbit led5_Direction at DDD6_bit;





bit flag_ok;
bit flag_g1;
bit flag_g2;
bit flag_fnf;
bit flag_ovft0;

char conta_ovf1=0;
char salva_overf1=0;
char salva_tmr0=0;
char salva_tmr1h;
char salva_tmr1l;
char cnt1=0;
char cnt2=0;
char cnt_prox=0;
long new_tmr1;
long old_tmr1a=0;
long old_tmr1b=0;
long old_tmr1c=0;
long dif=0;
long old_dif=0;
int cnt_it=0;
#line 88 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
 void TIMER1_ISR() iv IVT_ADDR_TIMER1_OVF ics ICS_AUTO {

 conta_ovf1++;
}
#line 100 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
void TIMER0_ISR() iv IVT_ADDR_TIMER0_OVF ics ICS_AUTO {
int a,b;

 b=TCNT1L;
 a=TCNT1H;
 salva_tmr1h=a;
 salva_tmr1l=b;
 TCNT1H=0;
 TCNT1L=0;
 salva_overf1=conta_ovf1;
 conta_ovf1=0;
 TOV1_bit=1;
 flag_ok=1;
 TCNT0=salva_tmr0;
}
#line 118 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
void delay10ms(){

 asm WDR ;
 delay_ms(10);
 asm WDR ;
}
#line 127 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
void delay100ms(){
 char a;

 for(a=0;a<10;a++)delay10ms();
}
#line 136 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
void initial_config(){

 TCCR0=0b00000111;
 ACSR=0X80;
 DDRB=0B00001111;
 DDRD=0B11101111;
 PORTB=0;
 PORTD=0;
 flag_ok=0;
 flag_g1=0;
 flag_g2=0;
 flag_fnf=0;
 flag_ovft0=0;
 delay100ms();
 delay100ms();
 delay100ms();
 SREG_I_bit = 0;
 TCNT0=0;
 asm WDR ;
 WDTCR=0B00001010;
 TCCR1A=0;
 TCCR1B=1;
 TIMSK=0B00000001;
}
#line 165 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
void var_delay_us(char v){

 if(v>=3)v=v-3; else return;
 while(v){
 v--;
 asm NOP;
 asm NOP;
 asm NOP;
 asm NOP;
 asm NOP;
 asm NOP;
 asm NOP;
 asm NOP;
 asm NOP;
 asm WDR ;
 }
}
#line 187 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
void gera_beep(char d,char e){
 char c;

 PORTD=0;
 ledf=0;
 lednf=0;
 for(c=0;c<d;c++){
 buzzer=1;
 var_delay_us(e);
 buzzer=0;
 var_delay_us(e);
 }
 }
#line 212 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
void beep_erros(char n){
char d;

 for(d=0;d<8;d++){
 gera_beep(255,255);
 }
 for(d=0;d<10;d++){
 delay100ms();
 }
 for(d=0;d<n;d++){
 gera_beep(230,150);
 delay100ms();
 delay100ms();
 delay100ms();
 delay100ms();
 }
 for(d=0;d<30;d++){
 delay100ms();
 }
 for(;;);
}
#line 239 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
void nonferrous(){
char a;

 lednf=1;
 ledf=0;
 for(a=0;a<=150;a++){
 buzzer=1;
 var_delay_us(130);
 buzzer=0;
 var_delay_us(130);
 }
 delay10ms();
 lednf=0;
 ledf=0;
}
#line 258 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
void ferrous(){
char a;

 lednf=0;
 ledf=1;
 for(a=0;a<=80;a++){
 buzzer=1;
 var_delay_us(250);
 buzzer=0;
 var_delay_us(250);
 }
 delay10ms();
 lednf=0;
 ledf=0;
}
#line 280 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
void dinamic_adjust_value(){



 asm WDR ;
 if(old_dif > dif) old_tmr1b=old_tmr1a;
 old_dif=dif;

 if(old_tmr1c>new_tmr1)old_tmr1c--;
 if(old_tmr1c<new_tmr1)old_tmr1c++;

 cnt1++;
 if(cnt1>= 15 ){
 cnt1=0;
 cnt2++;
 if(old_tmr1c>old_tmr1b)old_tmr1b++;
 if(old_tmr1c<old_tmr1b)old_tmr1b--;
 }
 if(cnt2>= 15 ){
 cnt2=0;
 if(old_tmr1a>old_tmr1b)old_tmr1a--;
 if(old_tmr1a<old_tmr1b)old_tmr1a++;
 }
}
#line 311 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
void efeito_sonoro_taranra(){
 char a;

 PORTD=0;
 lednf=0;
 ledf=0;
 for(a=0;a<3;a++){
 gera_beep(100,240);
 }
 for(a=0;a<3;a++){
 delay10ms();
 }
 for(a=0;a<3;a++){
 gera_beep(200,120);
 }
 for(a=0;a<3;a++){
 delay10ms();
 }
 for(a=0;a<3;a++){
 gera_beep(120,200);
 }
}
#line 343 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
void detecta_metal(){
 int aa,bb;
 char c,proximity;




 asm WDR ;
 flag_ok=0;
 while(!flag_ok);
 new_tmr1=(long)salva_tmr1l | (long)salva_tmr1h<<8 | (long) salva_overf1<<16;
 asm WDR ;
 if(new_tmr1>old_tmr1a){
 dif=new_tmr1 - old_tmr1a;
 flag_fnf=0;
 }
 else if(new_tmr1==old_tmr1a){
 dif=0;
 flag_fnf=0;
 }
 else if(new_tmr1<old_tmr1a){
 dif=old_tmr1a - new_tmr1;
 flag_fnf=1;
 }

 if(dif<= 4 ){
 cnt_prox=1;
 cnt_it++;
 if(cnt_it> 12000 ){
 cnt_it=0;
 efeito_sonoro_taranra();
 }
 dinamic_adjust_value();
 }

 else{

 cnt_it=0;



 aa=dif;
 bb=0x2000;
 for(c=0;c<=13;c++){
 asm WDR ;
 if(aa & bb)break;
 bb=bb>>1;
 }
 proximity=c;
 proximity=proximity>>2;

 if(proximity>=cnt_prox){
 cnt_prox++;
 }
 else{
 cnt_prox=1;
 portb=0;
 portd=0;
 c=c>>1;
 if(c>5)c=5;


 switch (c){

 case 0: led5=1;
 case 1: led4=1;
 case 2: led3=1;
 case 3: led2=1;
 case 4: led1=1;
 case 5: led0=1;
 }

 if(flag_fnf==1){
 nonferrous();
 }
 else{
 ferrous();
 }
 portb=0;
 portd=0;
 }

 }

}
#line 436 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
void testa_osc_sensor(){
 char new_tmr0;

 SREG_I_bit = 0;
 nonferrous();
 delay100ms();
 delay100ms();
 TCNT0=0;
 TOV0_bit=1;
 delay10ms();
 new_tmr0=TCNT0;
 flag_ovft0=0;
 if(TOV0_bit)flag_ovft0=1;
 TOV0_bit=1;
 asm WDR ;
 salva_tmr0=new_tmr0;

 if(250<new_tmr0){beep_erros(2);}
 else{
 if(flag_ovft0==1){beep_erros(2);}
 else{
 if(2<new_tmr0){
 if(149>=new_tmr0){beep_erros(1);}
 }
 flag_g1=1;
 }
 }

 if((new_tmr0==0)&& (flag_ovft0==0)){
 beep_erros(4);
 }
 salva_tmr0 = 0xff - new_tmr0;
}
#line 476 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
void oscillator_stability(){
unsigned char a,f,g,i;

 flag_g2=0;
 f=0;
 g=0;
 TCNT1L=0;
 TCNT1H=0;
 TCNT1L=0;
 TOV1_bit=1;
 TIMSK=0B00000101;
 TOV0_bit=1;
 SREG_I_bit = 1;
 flag_ok=0;
 while(!flag_ok);
 old_tmr1a=(long)salva_tmr1l | (long)salva_tmr1h<<8 | (long) salva_overf1<<16;

 do{
 asm WDR ;
 flag_ok=0;
 while(!flag_ok);
 new_tmr1=(long)salva_tmr1l | (long)salva_tmr1h<<8 | (long) salva_overf1<<16;
 if(new_tmr1 > old_tmr1a) old_tmr1a++;
 if(old_tmr1a > new_tmr1) old_tmr1a--;
 g++;
 if(g==0)beep_erros(3);
 if(old_tmr1a == new_tmr1){
 f++;
 if(f>3)flag_g2=1;
 }
 else{
 f=0;
 old_tmr1a=new_tmr1;
 }
 }while(flag_g2==0);


 old_tmr1b=old_tmr1a;
 old_tmr1c=old_tmr1a;
 PORTB=0;
 lednf=0;
 ledf=0;
 i=255;
 do{
 buzzer=1;
 var_delay_us(i);
 buzzer=0;
 var_delay_us(i);
 var_delay_us(i);
 i--;
 }while(i>100);

 for(a=0;a<5;a++)delay100ms();
 }
#line 535 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
void main() {

 initial_config();
 testa_osc_sensor();
 oscillator_stability();
#line 544 "C:/Arquivos de programas/Mikroelektronika/mikroC PRO for AVR/projetos/METAL_DET_ATMEGA8_16-PU/METAL_DET_LFM_ATMEGA8.c"
 for(;;){
 detecta_metal();
 }
}
